﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Telerik.WinControls;
using Telerik.WinControls.UI;

namespace _1449089GridFormatting
{
    public partial class RadForm1 : Telerik.WinControls.UI.RadForm
    {
        public RadForm1()
        {
            InitializeComponent();

            this.radGridView1.CellFormatting += radGridView1_CellFormatting;

            DataTable rightSouce = new DataTable();
            rightSouce.Columns.Add("Id", typeof(int));
            rightSouce.Columns.Add("Name", typeof(string));
            rightSouce.Columns.Add("CreatedOn", typeof(DateTime));
            for (int i = 0; i < 10; i++)
            {
                rightSouce.Rows.Add(i, "Item" + i, DateTime.Now.AddDays(i));
            }
            this.radGridView2.DataSource = rightSouce;
            this.radGridView2.AutoSizeColumnsMode = GridViewAutoSizeColumnsMode.Fill;

            DataTable leftSource = new DataTable();
            leftSource.Columns.Add("Id", typeof(int));
            leftSource.Columns.Add("Title", typeof(string));
            Random rand = new Random();
            for (int i = 0; i < 50; i++)
            {
                leftSource.Rows.Add(rand.Next(0, 11), "Row" + i);
            }
            this.radGridView1.DataSource = leftSource;
            this.radGridView1.AutoSizeColumnsMode = GridViewAutoSizeColumnsMode.Fill;

            this.radGridView2.CellValueChanged += radGridView2_CellValueChanged;
        }

        Font f = new Font("Arial", 8f, FontStyle.Bold);

        private void radGridView1_CellFormatting(object sender, CellFormattingEventArgs e)
        {
            if (e.Row.Cells[e.ColumnIndex].Tag != null && e.Row.Cells[e.ColumnIndex].Tag == "changed")
            {
                e.CellElement.ForeColor = Color.Red;
                e.CellElement.Font = f;
            }
            else
            {
                e.CellElement.ResetValue(LightVisualElement.ForeColorProperty, ValueResetFlags.Local);
                e.CellElement.ResetValue(LightVisualElement.FontProperty, ValueResetFlags.Local);
            }
        }

        private void radGridView2_CellValueChanged(object sender, GridViewCellEventArgs e)
        {
            int id = -1;
            for (int i = 0; i < this.radGridView1.Rows.Count; i++)
            {
                id = (int)this.radGridView1.Rows[i].Cells["Id"].Value;
                if (id == (int)e.Row.Cells["Id"].Value)
                {
                    this.radGridView1.Rows[i].Cells[e.ColumnIndex].Tag = "changed";
                    this.radGridView1.Rows[i].InvalidateRow();
                }
            }
        }

        private void radButton1_Click(object sender, EventArgs e)
        {
            foreach (GridViewRowInfo row in this.radGridView1.Rows)
            {
                foreach (GridViewCellInfo cell in row.Cells)
                {
                    cell.Tag = null;
                }
            }

            this.radGridView1.MasterTemplate.Refresh();
        }
    }

}